#pragma once

/*
	GP	 : Geodetic Position   ǥõ ǥ
	WGP	 : WGS 84 Geodetic Position
	BGP  : Bessel Ÿü Geodetic Position
	TM   : Transverse Macator  Ⱦ ī   ǥ
	KTM  : ѱ TM  ǥ (, ߺ,  )
	CTR  : Center ߽ǥ
	WCTR : WGS84 Center
	BCTR : Bessel Center
*/
class CgTrans
{
private:
	bool isKatech_;

public:
	enum enumParameterMethod { Molodensky=1, Bursa=2 };

public:
	void WGS84ToBesselTM(double Lati, double Long, double *pX, double *pY);
	void BesselTMToWGS84(double X, double Y, double *pLati, double *pLong, int izone=0);
private:
	// GWS84 ellipse GWS Ÿü
	const double AW_;
	const double FW_;

	// Bessel ellipse Bessel Ÿü
	const double AB_;
	const double FB_;

	// projection Datum  ô
	double OKKTM_; // ѱ
	const double OKUTM_; // UTM

	// ǥȯ parameters
	double tx_, ty_, tz_, TOMEGA_, tPhi_, TKAPPA_, ts_;
	enumParameterMethod TMODE_;
	
	double falseNorthing_;
	double falseEasting_;

	//geoid  ϱ   (迭 Index 0  )
	double xb_[30];
	double yb_[30];
	double hB_[30];
	double wB_[30];
	double XW_[30];
	double YW_[30];
	double hW_[30];
	double wW_[30];

public:
	CgTrans(void);
	~CgTrans(void);

private:
	void check(double *f);
	double fnSPHSN(double a, double es, double sphi);
	double fnSPHTMD(double ap, double bp, double cp, double dp, double ep, double sphi);
	double fnSPHSR(double a, double es, double sphi);
	double fnDENOM(double es, double sphi);

public:
	void SetTM();
	void SetTM128();

	//      WGS 84 ǥ  ǥ ȯ Ű Ѵ.
	//      dx, dy, dz, omega#, phi#, kappa#, ds, imode,
	//          x, y, z ̵, x, y, z  ȸ(), Scale (10-6)
	// ȯ(imode=1 -> Molodensky, 2 -> Bursa)
	void SetPara(enumParameterMethod imode, double dx, double dy, double dz, double omega, double phi, double kappa, double ds);

public:	
	//      WGS 84 ǥ  Ÿü  ǥ ȯѴ
	//      phiW#, lamW#, hW# , a#, f# (WGS , 浵, Ÿü, ȯ Ÿü ݰ, 1/)
	//      phiU#, lamU#, hU# (Bessel , 浵, Ÿü)
	//      f# 1/򵵷ν   299.1528128 Ǵ 1/299.1528128  0.003342773 Էµȴ.
	void WGP2GP(double phiW, double lamW, double hW, double a, double f, double *phiU, double *lamU, double *hU);

	//      WGS  ѱ   ȯѴ.
	//      phiW#, lamW#, hW# (WGS , 浵, Ÿü)
	//      phiB#, lamB#, hB# (Bessel , 浵, Ÿü)
	void WGP2BGP(double phiW, double lamW, double hW, double *phiB, double *lamB, double *hB);

	//       Ÿü  WGS  ȯѴ.
	//      phiU#, lamU#, hB#, a#, f# (ѱ , 浵, Ÿü, ȯ Ÿü ݰ, 1/)
	//      phiW#, lamW#, hW# (WGS , 浵, Ÿü)
	void GP2WGP(double phiU, double lamU, double hU, double a, double f, double *phiW, double *lamW, double *hW);
	

	//      WGS  ѱ  ǥ ȯѴ.
	//      phiW#, lamW#, hW#, izone, dlam# (WGS , 浵, Ÿü, 
	//			(=1, ߺ=2, =3), 浵  (ʴ,10,405))
	//      xB#, yB#, hB# (ѱ x, y, ǥ)
	void WGP2KTM(double phiW, double lamW, double hW, double dlam, double *xB, double *yB, double *hB, int izone=0);

	//      ѱ   WGS  ȯѴ.
	//      phiB#, lamB#, hB# (ѱ , 浵, Ÿü)
	//      phiW#, lamW#, hW# (WGS , 浵, Ÿü)
	void BGP2WGP(double phiB, double lamB, double hB, double *phiW, double *lamW, double *hW);

	//      ѱ  ǥ GWS  ȯѴ.
	//      xB#, yB#, hB#, izone, dlam#(ѱ X,Y, Ÿü, (=1, ߺ=2, =3), 浵 Ұ(ʴ,10.405)
	//      phiW#, lamW#, hW#
	void KTM2WGP(double xB, double yB, double hB, double dlam, double *phiW, double *lamW, double *hW, int izone=0);

	//       ǥ ǥ ȯѴ.
	//      phi#, lam#, a#, f#, x0#, y0#, phi0#, lam0#, ok# 
	//			, 浵, Ÿü ݰ, (1/299 ...), 
	//			 ǥ(x=, y=),  , 浵, 浵   
	//			(ʴ, 10.405ʵ), ô ( 1.0000(ѱ), 0.9996(UTM))
	//      xn#, ye# ( x(), y() ǥ)
	void GP2TM(double phi, double lam, double a, double f, double x0, double y0, double phi0, double lam0, double ok, double *xn, double *ye);


	//      ǥ ǥ ȯѴ.
	//      xn#, ye#, a#, f#, x0#, y0#, phi0#, lam0#, ok# ǥ,  ܴ GP2 TM 
	//      phi#, lam# ( , 浵)
	void TM2GP(double xn, double ye, double a, double f, double x0, double y0, double phi0, double lam0, double ok, double *phi, double *lam);

	//        ǥ ȯѴ.
	//      phiB#, lamB#, izone, dlam# ( , 浵, (=1, ߺ=2, =3), 浵  (ʴ))
	//      xB#, yB# (  x(), y() ǥ
	void BGP2KTM(double phiB, double lamB, double dlam, double *xB, double *yB, int izone=0);

	//      ѱ  ǥ  ȯѴ.
	//      xB#, yB#, izone, dlam#, ( ǥ, (=1, ߺ=2, =3), 浵  (ʴ))
	//       phiB#, lamB# (  , 浵)
	void KTM2BGP(double xB, double yB, double dlam, double *phiB, double *lamB, int izone=0);

	//      MOLODENSKY ȯ Ͽ WGS 84 ǥ  ǥ ȯѴ.
	//      xW#, yW#, zW# (WGS 84  ǥ)
	//      xB#, yB#, zB# ( ǥ, 츮  Bessel)
	//      ̶ ȯŰ Sub set para Է  ȴ.
	void TransMolod(double xW, double yW, double zW, double *xB, double *yB, double *zB);

	//      BURSA ȯ Ͽ WGS 84 ǥ  ǥ ȯѴ.
	//    TransMolodensky 
	//      ̶ ȯŰ Sub set para Է  ȴ.
	void TransBursa(double xW, double yW, double zW, double *xB, double *yB, double *zB);

	//      MOLODENSKY ȯ Ͽ  ǥ WGS 84 ǥ ȯѴ.
	//      xB#, yB#, zB#  ( ǥ, 츮  Bessel)
	//      xW#, yW#, zW# (WGS 84  ǥ)
	//      ̶ ȯŰ Sub set para Է  ȴ.
	void InverseMolod(double xB, double yB, double zB, double *xW, double *yW, double *zW);

	//      BURSA ȯ Ͽ  ǥ WGS 84 ǥ ȯ Ѵ.
	//    InverseMolod 
	//      ̶ ȯŰ Sub set para Է  ȴ.
	void InverseBursa(double xB, double yB, double zB, double *xW, double *yW, double *zW);

	//      ǥ ǥ ȯѴ.
	//      x#, y#, z#, a#, f#
	// ǥ, Ÿü, ݰ, (1/299. )
	//      phi#, lam#, h#
	// , 浵, Ÿü
	void CTR2GP(double x, double y, double z, double a, double f, double *phi, double *lam, double *h);

	//       ǥ ǥ ȯѴ.
	//      phi#, lam#, h#, a#, f#
	//			, 浵, Ÿü, Ÿüݰ, (1/299. )
	//      x#, y#, z# ǥ
	void GP2CTR(double phi, double lam, double h, double a, double f, double *x, double *y, double *z);

	//      WGS  ǥ ȯѴ.
	//      phi#, lam#, h# GPS , 浵
	//      x#, y#, z# WGS 84 ǥ
	void WGP2WCTR(double phi, double lam, double h, double *x, double *y, double *z);

	//      WGS ǥ  ȯѴ.
	//      xW#, yW#, zW#
	// WGS ǥ
	//      xB#, yB#, zB#
	//  ǥ
	void BCTR2BGP(double x, double y, double z, double *phi, double *lam, double *h);
	
	//        ȯѴ.
	//      x#, y#, z#
	// ǥ
	//      phi#, lam#, h#
	//  , 浵
	void WCTR2BCTR(double xW, double yW, double zW, double *xB, double *yB, double *zB);

	//        ǥ ȯѴ.
	//      phi#, lam#, h#  , 浵, ǥ
	//      x#, y#, z#  ǥ
	void BGP2BCTR(double phi, double lam, double h, double *x, double *y, double *z);

	//       WGS ǥ ȯѴ.
	//      xB#, yB#, zB#
	//  ǥ
	//      xW#, yW#, zW#
	// WGS ǥ
	void BCTR2WCTR(double xB, double yB, double zB, double *xW, double *yW, double *zW);

	//      WGS  WGS  ȯѴ.
	//      x#, y#, z#
	// WGS ǥ
	//      phi#, lam#, h#
	// WGS , 浵, Ÿü
	void WCTR2WGP(double x, double y, double z, double *phi, double *lam, double *h);

	//      WGS Ǵ BesselŸü geoid 
	//      phi#, lam# , 浵
	//      geoid
	//      WGS(Wgeoid) Ǵ Bessel (Bgeoid)κ  Ÿü   Ÿü 
	//			ȯ  ǥ     ִ.
	// ǥ = Ÿü - geoid  ȴ.
	//  program   Ͽ geoid Ѵ. 
	// WGS   ȯϴ Ű   ޶,  󼭵 ޶. 
	// 츮 αٿ WGS Ÿü geoid 23 ~ 29m̸, Bessel Ÿü geoid -42  -65m  Ѵ. 
	//  program      (Inverse Distance Weight Method) ϵϰ ִ. 
	//  κп    ʿϴ.
	double Wgeoid(double phi, double lam);
	double Bgeoid(double phi, double lam);
};
