// tstGoogle.cpp : ܼ  α׷   մϴ.
//

#include "stdafx.h"

#include <string>
#include <math.h>
#include <windows.h>
#include <wininet.h>
#include <time.h>

using namespace std;

#include "gTrans.h"
#include "GoogleMap.h"

void GenerateGCP(const char* fileName, double minX, double minY, double maxX, double maxY) {
	FILE *pFile = fopen(fileName, "wt");

	fprintf(pFile, "xge gcp file\n");
	fprintf(pFile, "%lf\t%lf\t%lf\t%lf", minX, minY, maxX, maxY);

	fclose(pFile);
}

bool DownloadTile(const char *URL, const char *Path)
{
	HINTERNET hInternet, hURL;
	HANDLE hFile;
	DWORD Size;
	DWORD dwRead,dwWritten,Recv=0;
	TCHAR buf[100000];

	// ͳ 
	hInternet=InternetOpen("HTTPTEST", INTERNET_OPEN_TYPE_PRECONFIG,
		NULL, NULL, 0);
	if (hInternet == NULL) {
		return FALSE;
	}

	// URL 
	hURL=InternetOpenUrl(hInternet,URL,NULL,0,INTERNET_FLAG_RELOAD,0);
	if (hURL==NULL) {
		InternetCloseHandle(hInternet);
		return FALSE;
	}

	//   Ѵ.
	hFile=CreateFile(Path,GENERIC_WRITE,0,NULL,
		CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

	do {
		// ٿε޾  Ͽ Ѵ.
		InternetQueryDataAvailable(hURL,&Size,0,0);
		InternetReadFile(hURL,buf,Size,&dwRead);
		WriteFile(hFile,buf,dwRead,&dwWritten,NULL);

		// ٿε  ޽ 
		Recv+=dwWritten;
	} while (dwRead != 0);

	InternetCloseHandle(hURL);
	InternetCloseHandle(hInternet);
	CloseHandle(hFile);

	return true;
}

int _tmain(int argc, _TCHAR* argv[])
{
	CgTrans gT;
	CGoogleMap gm;

	if(argc!=5) {
		printf("usage:\n     tstGoogleMap.exe  KatechX  KatechY  zoomLevel(1~18)  FileName\n");
		return 0;
	}

	double degrad = atan(1.0)/45.0;

	const double ts = -6.43;
	const double TKAPPA = -1.63;
	const double tPhi = -2.31;
	const double TOMEGA = 1.16;
	const double tx = 115.8;
	const double ty = -474.99;
	const double tz = -674.11;

	gT.SetPara(CgTrans::Bursa, tx, ty, tz, TOMEGA, tPhi, TKAPPA, ts);
	gT.SetTM128();

	int zoom = atoi(argv[3]);

	double tmX = atof(argv[1]);
	double tmY = atof(argv[2]);
	char *outputFileName = argv[4];
	double Latitude;
	double Longitude;

	printf("----------------------------------------------\n");
	printf("InputX: %lf\tInputY: %lf\n", tmX, tmY);
	printf("----------------------------------------------\n");

	gT.BesselTMToWGS84(tmY, tmX, &Latitude, &Longitude);
	printf("InputLati: %lf\tInputLong: %lf\n", Latitude, Longitude);

	int tileY = gm.GetMercatorLatitude(Latitude, zoom); // 
	int tileX = gm.GetMercatorLongitude(Longitude, zoom); // 浵

	string TileId = gm.GetSatTileId(tileY, tileX, zoom);
	srand( (unsigned)time( NULL ) );
	string url = gm.GetSatFullUrl(TileId, (rand()/INT_MAX)%4);

	printf("----------------------------------------------\n");
//	printf("%s", url.c_str());
//	printf("\n--------------------------------------------\n");

	double minLati, minLong, maxLati, maxLong;
	gm.GetMinBounds(tileY, tileX, zoom, &minLong, &minLati);
	gm.GetMaxBounds(tileY, tileX, zoom, &maxLong, &maxLati);

	printf("<Tile Bound> : \n");
	printf("minLong: %lf\tminLati: %lf\n", minLong, minLati);
	printf("maxLong: %lf\tmaxLati: %lf\n", maxLong, maxLati);

	printf("----------------------------------------------\n");

	double minX, minY, maxX, maxY, X, Y;
	gT.WGS84ToBesselTM(minLati, minLong, &minY, &minX);
	gT.WGS84ToBesselTM(maxLati, maxLong, &maxY, &maxX);
	gT.WGS84ToBesselTM(Latitude, Longitude, &Y, &X);

	printf("MinX: %lf\tMinY: %lf\n", minX, minY);
	printf("MaxX: %lf\tMaxY: %lf\n", maxX, maxY);
	printf("----------------------------------------------\n");
	printf("TransX: %lf\tTransY: %lf\n\n", X, Y);

	printf("downloading... ");
	string jpgFile(outputFileName);
	jpgFile += ".jpg";
	DownloadTile(url.c_str(), jpgFile.c_str());
	string gcpFile(outputFileName);
	gcpFile += ".gcp";
	GenerateGCP(gcpFile.c_str(), minX, minY, maxX, maxY);
	printf("completed.\n");

	return 0;
}